// DataExchangeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DataExchange.h"
#include "DataExchangeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma pack(push, 1)
struct NcfRecord {
  WORD  DataLen;
  WORD  SourceLen;
  BYTE  Version;
  WORD  Year;
  BYTE  Month;
  BYTE  Day;
  BYTE  Hour;
  BYTE  Minute;
  BYTE  Sec;
  DWORD Mcsec;
  BYTE  Flags;
  BYTE  SigLevel;
  BYTE  Rate;
  BYTE  Band;
  BYTE  Channel;
  BYTE  Reserved[3];
};
#pragma pack(pop)


/////////////////////////////////////////////////////////////////////////////
// CDataExchangeDlg dialog

CDataExchangeDlg::CDataExchangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDataExchangeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDataExchangeDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Listen = false;
	m_Accept = false;
}

void CDataExchangeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDataExchangeDlg)
	DDX_Control(pDX, IDC_SPIN, m_Spin);
	DDX_Control(pDX, IDC_PORT, m_CPort);
	DDX_Control(pDX, IDC_LIST, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDataExchangeDlg, CDialog)
	//{{AFX_MSG_MAP(CDataExchangeDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_PORT, OnChangePort)
	ON_BN_CLICKED(IDC_LISTEN, OnListen)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
    {WM_USER + 100, 0, 0, 0, AfxSig_vv, (AFX_PMSG)(AFX_PMSGW)(void (AFX_MSG_CALL CWnd::*)(void))&OnAccept},
    {WM_USER + 101, 0, 0, 0, AfxSig_vv, (AFX_PMSG)(AFX_PMSGW)(void (AFX_MSG_CALL CWnd::*)(void))&OnRead
 },	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDataExchangeDlg message handlers

BOOL CDataExchangeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Link spin to edit box and set limits
	m_Spin.SetBuddy(&m_CPort);
	m_Spin.SetRange32(0, 65535);
	m_CPort.SetWindowText("5050");

	// Create socket
	m_Socket = socket(AF_INET, SOCK_STREAM, 0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDataExchangeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void CDataExchangeDlg::OnAccept() 
{
	sockaddr_in sa;
	int size;
	CString msg;
	char hdr[3];
	unsigned short *ps = (unsigned short *)hdr;

	if (!m_Accept) {
		size = sizeof(sa);
		m_OpenSocket = accept(m_Socket, (sockaddr*)&sa, &size);
		msg.Format("Accepted connection from %s", inet_ntoa(sa.sin_addr));
		m_List.AddString(msg);
		
		m_Accept = true;
		m_Num = 1;
		m_Pos = 0;
		WSAAsyncSelect(m_OpenSocket, m_hWnd, WM_USER + 101, FD_READ);
	}
}

void CDataExchangeDlg::OnRead() 
{
	int size, total;
	CString msg;
	static unsigned char *pkt;
	char *res, str[10];
	struct NcfRecord ncf;

	if (m_Accept) {
		if (m_Pos < sizeof(NcfRecord) + 1) {
			total = m_Pos;
			while (total < sizeof(NcfRecord)) {
				size = recv(m_OpenSocket, (char *)&ncf + total, sizeof(NcfRecord) - total, 0);
				if (size == -1) {
					m_Pos = total;
					return;
				} else if (size == 0) {
					m_Accept = false;
				}
				total += size;
			}
			
			pkt = new unsigned char[ncf.DataLen];
			if (!pkt) {
				return;
			}
			total = 0;
		} else {
			total = m_Pos - sizeof(NcfRecord);
		}
		while (total < ncf.DataLen) {
			size = recv(m_OpenSocket, (char *)pkt + total, ncf.DataLen - total, 0);
			if (size == -1) {
				m_Pos = total + sizeof(NcfRecord);
				return;
			} else if (size == 0) {
				m_Accept = false;
			}
			total += size;
		}

		res = new char[200 + (3 * ncf.DataLen)];
		if (!res) {
			delete[] pkt;
			return;
		}
		sprintf(res, "Packet #%u, Size: %u, Direction: ", m_Num, ncf.DataLen);
		switch (ncf.Reserved[0]) {
		case 0x00:
			strcat(res, "pass-through");
			break;

		case 0x01:
			strcat(res, "inbound");
			break;

		case 0x02:
			strcat(res, "outbound");
			break;

		default:
			strcat(res, "invalid");
			break;
		}

		strcat(res, ", Data: 0x");
		m_Num++;
		total = 0;
		while (total < ncf.DataLen) {
			sprintf(str, "%2.2X", pkt[total]);
			strcat(res, str);

			total++;
		}
		m_List.AddString(res);
		size = strlen(res);

		delete[] pkt;
		delete[] res;
	}
	m_Pos = 0;
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDataExchangeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDataExchangeDlg::OnChangePort() 
{
	CString port;
	int num;

	m_CPort.GetWindowText(port);
	sscanf(port, "%d", &num);
	if (num < 0) {
		m_CPort.SetWindowText("0");
	} else if (num > 65535) {
		m_CPort.SetWindowText("65535");
	}
}

void CDataExchangeDlg::OnListen() 
{
	CString port;
	int num;
	sockaddr_in sa;

	if (!m_Listen) {
		m_CPort.GetWindowText(port);
		sscanf(port, "%d", &num);
	
		sa.sin_family = AF_INET;
		sa.sin_addr.S_un.S_addr = 0;
		sa.sin_port = htons(num);
		bind(m_Socket, (sockaddr*)&sa, sizeof(sa));
		listen(m_Socket, 1);
		WSAAsyncSelect(m_Socket, m_hWnd, WM_USER + 100, FD_ACCEPT);

		m_Listen = true;
	}
}


void CDataExchangeDlg::OnSend() 
{
  short len;
  short rate = 2;
  char msg[] = "Sample packet text. You shouldn't send this in real life!";
  PUCHAR packet = (PUCHAR) malloc(strlen(msg) + 4);
  if (!packet){
	  AfxMessageBox("Low memory", MB_ICONERROR);
	  return;
  }
  if (m_Accept)
	{
    if (AfxMessageBox("Are you sure?", MB_YESNO) != IDYES ) 
		  return;

    len = strlen(msg);
	*((PUSHORT) packet) = len;
	*((PUSHORT) (packet + 2)) = rate;
	memcpy(packet + 4, msg, strlen(msg));
	send(m_OpenSocket, (char *)packet, strlen(msg) + 4, 0);
  } else 
		AfxMessageBox("Not connected", MB_ICONERROR);
  free(packet);
}


void CDataExchangeDlg::OnClear() 
{
	m_List.ResetContent();	
}

BOOL CDataExchangeDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	closesocket(m_Socket);

	return CDialog::DestroyWindow();
}

